"Cp" <-
function (x,y,knots,degree,alpha=log(length(x)),J,sigma2.hat,RSS) 
{# Mallows' Cp criterion for knot selection
# J = number of knots in full model
j<-J-length(knots) # j = 0 corresponds to full model
                   # j = J corresponds to most restrictive model
                   # sigma2.hat = variance estimate from full model
RSS+alpha*(J+degree+1-j)*sigma2.hat
}
