"dpilsp" <-
function (x,y,knots,degree=3,delta) 
{
n<-length(x)
x.1 <- min(x)
diffrange <- diff(range(x))
x <- (x-x.1)/diffrange
if (missing(delta)) delta <- diff(range(x))/(3*n)
knots <- (knots-x.1)/diffrange
y.sp<-splinel2(x,y,knots=knots,degree=5)
m.approx<-function(x){approx(y.sp$x,y.sp$y,x)$y}
y.hat<-m.approx(x)
sigma2<-sum((y.hat-y)^2,na.rm=TRUE)/(n-length(knots)-3)
accept<-NULL
for (xx in x) {
if (sum(((xx>=(knots-delta))*(xx<=(knots+delta))))==0)
{accept<-c(accept,xx)}
}
m4<-median(deriv4(m.approx,accept)^2,na.rm=TRUE)
h1<-3.633*(sigma2/(n*m4))^(1/9)/2.623
accept<-NULL
# delta <- min(h1,.5/n)
for (xx in x) {
if (sum(((xx>=(knots-delta))*(xx<=(knots+delta))))==0)
{accept<-c(accept,xx)}
}
y.lsp<-locspline(x,y,h=h1,knots=knots,degree=degree)
mb.approx<-function(x){approx(y.lsp$x,y.lsp$y,x)$y}
y.lsp2 <- locsplinedf(x,y,h=h1,knots=knots,degree=degree)
y.hat <- y.lsp2$fitted.values
df <- y.lsp2$df
sigma2 <- sum((y.hat-y)^2, na.rm=TRUE)/df
xbar4<-median(deriv4(mb.approx,accept)^2,na.rm=TRUE)
h2<-3.633*(sigma2/(n*xbar4))^(1/9)/2.623
h1 <- h1*diffrange
h2 <- h2*diffrange
list(h1=h1,h2=h2)
}
