"knot.selection.step" <-
function (x,y,degree=3,current.knots=x[seq(1,length(x),3)],more.knots=FALSE,new.number=10) 
{
n<-length(x)
mesh<-mean(abs(diff(x)))
if (more.knots) {new.knots<-runif(new.number,min=min(x),max=max(x))}
else {new.knots<-NULL}
all.knots<-sort(c(current.knots,new.knots))
J<-length(all.knots)
original.knot.indices<-seq(1,J)
y.sp<-splinel2(x,y,knots=all.knots,degree=degree)
s2<-y.sp$RSS/(length(x)-length(all.knots)-degree-1)
t<-abs(y.sp$t)[1:length(all.knots)]
delete.index<-original.knot.indices[t==min(t)]
knots<-all.knots[-delete.index]
original.knot.indices<-original.knot.indices[-delete.index]
Cpj<-NULL
for (j in 1:(J-1)){
y.sp<-splinel2(x,y,knots=knots,degree=degree)
t<-abs(y.sp$t)[1:length(knots)]
delete.index<-c(delete.index,original.knot.indices[t==min(t)])
knots<-all.knots[-delete.index]
original.knot.indices<-seq(1,J)[-delete.index]
Cpj<-c(Cpj,Cp(x,y,knots=knots,J=J,alpha=6,sigma2.hat=s2,degree=degree,RSS=y.sp$RSS))
}
knots<-all.knots[-delete.index[seq(1,min(seq(1,J)[Cpj==min(Cpj)]))]]
# list(data=list(x=x,y=y),xmin=x.1,xrange=diffrange,Cp=min(Cpj),delete.index=delete.index,knots=knots,t=y.sp$t)
c(knots=knots)
}
