"knots.AICC" <-
function (x, y, degree) 
{
    n <- length(x)
    h.opt <- 100*diff(range(x))
    k1 <- x[seq(3,n-2,length=round(sqrt(n)))]
    k1 <- knot.selection.step(x, y, degree=degree, current.knots=k1)
    AICC.min <- locsplineAICC(x, y, degree=degree, knots=k1, h=h.opt)
    
    for (j in 1:length(k1)){
        k <- length(k1)
        AICC <- NULL
        for (i in 1:k){
            AICC <- c(AICC, locsplineAICC(x, y, degree=degree, knots=k1[-i], h=h.opt))
}
    if (min(AICC) < AICC.min) {
        AICC.min <- min(AICC)
        k1 <- k1[-(AICC==min(AICC))]
}
    else{
break()
}
}
    list(knots = k1, AICC=AICC.min)
}
