"locsplinedf" <-
function(x,y,h,degree=3,knots=quantile(x,c(.25,.5,.75)),range.x=range(x)){
n<-length(x)
diffrange <- diff(range(x))
knots<-c(min(x)-diffrange,knots,max(x)+diffrange)
p<-length(knots)-1+degree
Sny<-Sn<-matrix(0,nrow=p,ncol=p+1)
WORK1<-rep(0,p)
WORK2<-matrix(0,nrow=p,ncol=p)
WORK3<-rep(0,p+1)
Kxxo<-rep(0,n)
xbs<-rep(0,p)
predbs<-matrix(0,nrow=p,ncol=n)
betahat<-rep(0,p)
hat<-fhat<-rep(0,n)
z<-.Fortran("locsplinedf",as.double(x),as.double(y),as.integer(n),
as.double(h),as.integer(degree),as.double(knots),as.integer(p),
as.double(Sn),as.double(Sny),as.integer(WORK1),as.double(WORK2),as.double(WORK3),as.double(Kxxo),
as.double(xbs),as.double(predbs),as.double(betahat),as.double(fhat),as.double(hat), PACKAGE="kernelspline")
names(z)<-c("x","y","n","h","degree","knots","p","Sn","Sny","WORK1",
"WORK2","WORK3","Kxxo","xbs","predbs","betahat","fhat","hat")
df <- n - sum(z$hat)
gcv <- sum((y-z$fhat)^2)/df^2
cv <- sum((y-z$fhat)^2/(1-z$hat)^2)
AIC <- sum((y-z$fhat)^2)+2*sum(z$hat)
resids <- y - z$fhat
list(fitted.values=z$fhat,hat.diagonal=z$hat,knots=z$knots,p=z$p,n=z$n,h=z$h,degree=z$degree,data=list(x=z$x,y=z$y,resids=resids),df=df, 
gcv=gcv, AIC=AIC, cv=cv)
}


