"splinel2" <-
function(x,y,gridsize=401,degree=3,knots=quantile(x,c(.25,.5,.75))){
# x must be sorted
n<-length(x)
gridpts<-rep(0,gridsize)
margin<-diff(range(x))/n
knots<-c(min(x)-margin,knots,max(x)+margin)
p<-length(knots)-1+degree
Sn<-matrix(0,nrow=p,ncol=p+1)
Scopy<-Sn
se<-setmp<-WORK1<-rep(0,p)
WORK2<-matrix(0,nrow=p,ncol=p)
WORK3<-rep(0,p+1)
Kxxo<-rep(0,n)
xbs<-rep(0,p)
predbs<-matrix(0,nrow=p,ncol=n)
betahat<-rep(0,p)
fhat<-rep(0,gridsize)
z<-.Fortran("splinel2",as.double(x),as.double(y),as.integer(n),as.double(gridpts),
as.integer(gridsize),as.integer(degree),as.double(knots),as.integer(p),
as.double(Sn),as.integer(WORK1),as.double(WORK2),as.double(WORK3),as.double(Kxxo),
as.double(xbs),as.double(predbs),as.double(betahat),as.double(fhat),as.double(Scopy),as.double(setmp),as.double(se),
PACKAGE="kernelspline")
names(z)<-c("x","y","n","gridpts","gridsize","degree","knots","p","Sn","WORK1",
"WORK2","WORK3","Kxxo","xbs","predbs","betahat","fhat","S","setmp","se")
RSS<-sum((approx(z$gridpts,z$fhat,x)$y-y)^2,na.rm=T)
z$se<-sqrt(z$se*RSS/(n-p))
list(x=z$gridpts,y=z$fhat,knots=z$knots,p=z$p,n=z$n,degree=z$degree,data=list(x=z$x,y=z$y),betahat=z$betahat,se=z$se,RSS=RSS,t=z$betahat/z$se)
}
