\name{Cp}
\alias{Cp}
\title{Cp}
\description{
This function calculates an analogue of Mallows' Cp statistic for
least square splines.
}
\usage{
Cp(x, y, knots, degree, alpha = log(length(x)), J, sigma2.hat, RSS)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{The explanatory variable}
  \item{y}{The response variable}
  \item{knots}{A vector containing the knots }
  \item{degree}{The degree of the least squares spline }
  \item{alpha}{The penalty weight }
  \item{J}{The number of knots in the full model }
  \item{sigma2.hat}{An estimate of the error variance }
  \item{RSS}{The residual sum of squares for the current spline
estimate }
}
\value{
  A vector with a single component.
}
\references{ ~put references to the literature/web site here ~ }
\author{W.J. Braun}
\keyword{models}
