\name{bspline}
\alias{bspline}
\title{B-splines}
\description{
B-spline basis functions.
}
\usage{
function(x, xl, xr, ndx, bdeg)
}
\arguments{
  \item{x}{explanatory variable vector}
  \item{xl}{lower knot}
  \item{xr}{upper knot}
  \item{ndx}{number of subintervals}
  \item{bdeg}{bspline degree}
}
\value{
  \item{B}{B-spline values}
  }
\reference{
Eilers, P.H.C. and Marx, B.D. (1996) Flexible smoothing
with B-splines and penalties.  Statistical Science 11:89--121.
}
\author{W.J. Braun }
\keyword{models}
