\name{locsplinedf}
\alias{locsplinedf}
\title{Degrees of freedom for local spline }
\description{
   This function calculates residuals and effective degrees
of freedom for kernel splines.
}
\usage{
locsplinedf(x, y, h, degree = 3, knots = quantile(x, c(0.25, 0.5, 0.75)), range.x = range(x))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ ~~Describe \code{x} here~~ }
  \item{y}{ ~~Describe \code{y} here~~ }
  \item{h}{ ~~Describe \code{h} here~~ }
  \item{degree}{ ~~Describe \code{degree} here~~ }
  \item{knots}{ ~~Describe \code{knots} here~~ }
  \item{range.x}{ ~~Describe \code{range.x} here~~ }
}
\value{
A list consisting of
  \item{fitted.values}{Description of 'comp1'}
  \item{hat.diagonal}{Description of 'comp2'}
  \item{knots}{knots}
  \item{p}{number of terms}
  \item{n}{sample size}
  \item{h}{bandwidth}
  \item{data}{a list consisting of x, y, and residuals}
  \item{gcv}{generalized cross-validation statistic}
  \item{AIC}{Akaike information criterion}
  \item{cv}{cross-validation statistic}
}
\author{W.J. Braun }
\keyword{models }
