"h.AICC" <-
function (x, y, degree) 
{
    h.unit <- diff(range(x))
    n <- length(x)
    h.lower.bound <- ceiling(-log(n, 1.2))
    h.set <- 1.2^seq(h.lower.bound,1,1)*h.unit
    AICC <- NULL
    for (h in h.set){
        AICC <- c(AICC, locsplineAICC(x, y, degree=degree, knots=NULL, h=h))
}
    AICC.min <- min(AICC)
    h.opt <- h.set[AICC==AICC.min]
    list(h = h.opt, AICC=AICC.min)
}
