"hknots" <-
function (x, y, degree) 
{
    k1 <- knots.pre(x, y)
    if (length(k1) > 0) {
        k2 <- knot.selection.step(x, y, degree = degree, current.knots = k1)
    }
    else {
        k2 <- NULL
    }
    h <- dpilsp(x, y, degree = degree, knots = k2)$h1
    k3 <- knots.post1(x, y, degree = degree, knots = k2, h = h)
    k4 <- knot.selection.step(x, y, degree = degree, 
        current.knots = k3)
    h <- dpilsp(x, y, degree = degree, knots = k4)$h2
    list(knots = k4, h = h)
}
