"locspline" <-
function(x,y,h,gridsize=401,degree=3,knots=quantile(x,c(.25,.5,.75)),range.x=range(x)){
n<-length(x)
gridpts<-seq(range.x[1],range.x[2],length=gridsize)
diffrange <- diff(range(x))
knots<-c(min(x)-diffrange,knots,max(x)+diffrange)
p<-length(knots)-1+degree
Sn<-matrix(0,nrow=p,ncol=p+1)
WORK1<-rep(0,p)
WORK2<-matrix(0,nrow=p,ncol=p)
WORK3<-rep(0,p+1)
Kxxo<-rep(0,n)
xbs<-rep(0,p)
predbs<-matrix(0,nrow=p,ncol=n)
betahat<-rep(0,p)
fhat<-rep(0,gridsize)
z<-.Fortran("locspline",as.double(x),as.double(y),as.integer(n),as.double(gridpts),
as.integer(gridsize),as.double(h),as.integer(degree),as.double(knots),as.integer(p),
as.double(Sn),as.integer(WORK1),as.double(WORK2),as.double(WORK3),as.double(Kxxo),
as.double(xbs),as.double(predbs),as.double(betahat),as.double(fhat), PACKAGE="kernelspline")
names(z)<-c("x","y","n","gridpts","gridsize","h","degree","knots","p","Sn","WORK1",
"WORK2","WORK3","Kxxo","xbs","predbs","betahat","fhat")
list(x=z$gridpts,y=z$fhat,knots=z$knots,p=z$p,n=z$n,h=z$h,degree=z$degree,data=list(x=z$x,y=z$y))
}
