\name{dpilp}
\alias{dpilp}
\title{Direct Plug In Bandwidth for local polynomial }
\description{
  This function computes a bandwidth for kernel polynomial
regression using a naive adjustment of Ruppert et al's (1995)
method for local linear.
}
\usage{
dpilp(x, y, degree = 3)
}
\arguments{
  \item{x}{The explanatory variable }
  \item{y}{The response variable }
  \item{degree}{The degree of the spline }
}
\value{
  The selected bandwidth.
}
\reference{
Ruppert, D., Sheather, S.J. and Wand, M.P. (1995) An Effective
Bandwidth Selector for Local Least Squares Regression. 
J. Amer. Stat. Assoc. 90: 1257--1270.
}
\author{W.J. Braun }
\keyword{models}
