\name{knots.AICC}
\alias{knots.AICC}
\title{Knot Selector using AICC}
\description{
  This function automatically chooses knots 
for spline regression using
the Hurvich et al (1999) AICC.
}
\usage{
knots.AICC(x, y, degree)
}
\arguments{
  \item{x}{explanatory variable vector}
  \item{y}{response variable vector}
  \item{degree}{spline degree}
}
\value{
  If it is a LIST, use
  \item{knots }{A vector of knots}
  \item{AICC}{The value of the AICC}
}
\reference{
Hurvich, C.M.,  Simonoff, J.S., and Tsai, C.-L. (1998)
Smoothing Parameter Selection in Nonparametric Regression
Using an Improved Akaike Information Criterion, J. Roy. Stat. Soc.
B 60: 271--293.
}
\author{W.J. Braun }
\keyword{models}
